
#DEFINE lINELENGTH  240

#define endArray { "ENDIF",  "END", "ENDCASE", "ENDDO","NEXT" }
#define keyWords { "DO", "WHILE", "FOR", "NEXT", "CASE", "LOOP", "EXIT", ;
                   "IF", "ENDIF", "END", "ELSEIF", "ENDDO", "ENDCASE", "PROC", "RETURN" }

#define ifArray  { "ENDIF", "ELSE" }





FUNC interpret(_data_,__ppc,__avars )
local __1line,__pc,__lcount, loopData, subArray := {},__i,__temp
local iStack , expr := "",  fTok, forStack, forInfo, pos, count,__cl := 0,__isCaseEval := .f.
local procName, pcStack, varElse:=.f.,retval :="",__aparams

memvar   execode,vartable
private execode := {},vartable := {}


If valtype(_data_) == "C"

  m->exeCode := Compile2A( _data_ )
  _data_  := NIL
  __pc := 1

Else
  m->execode := _data_
  __pc := __ppc
Endif

 iStack := StackNew()
 forStack := StackNew()
 pcStack := StackNew()

__lcount :=  len(m->exeCode)

While __pc <= __lcount
 __1line := m->exeCode[__pc]

 fTok := FirstTok( __1line )

 do case

   Case fTok == "PARAMETERS"
   If __avars <> NIL
     m->Vartable := addtoVartable(__1line,10)
     For __i := 1 to len(m->vartable)
     __temp := m->vartable[__i]
     private  &__temp
     &__temp := __avars[__i]
     Next
   Endif

     __pc++
     loop




   Case fTok == "PRIVATE"
     m->Vartable := addtoVartable(__1line,7)
     For __i := 1 to len(m->vartable)
     __temp := m->vartable[__i]
     private  &__temp
     Next
     __pc++
     loop

   case fTok == "WHILE"
    expr := right( ltrim( __1line), len( ltrim(__1line))-5)
    if lineEval( expr ) == .t.
      StackPush( iStack, { "WH", __pc, expr } )
    else
      __pc := MatchEnd(  __pc+1,0 )
      loop
    endif
    __pc++
   loop

  case ascan( endArray, {|x| x == ftok } ) > 0
   loopData := StackTop( iStack )
   if loopData[1] == "WH"
    if lineEval( loopData[3] )
      __pc := loopData[2] +1
      loop
    else
      StackPop( iStack )
      __pc++
      loop
    endif
   elseif  loopData[1] == "IF"
      StackPop( iStack )
      __pc++
      loop
   elseif  loopData[1] == "FOR"
      forInfo := StackTop( iStack )
      eval( forInfo[4] )
      if eval( forInfo[3] )
        __pc := forInfo[5]
        loop
      else
        StackPop(iStack )
        __pc++
        loop
      endif
   elseif  loopData[1] == "CASE"
      __cl--
      __IsCaseEval := if(__cl > 0,.t.,.f.)
     StackPop( iStack )
     __pc++
     loop


   else
     StackPop( iStack )
     __pc++
     loop
   endif


  case fTok == "FOR"
    forInfo := ForArray( __1line, __pc+1 )
    StackPush( iStack, forInfo )
    if eval( forInfo[3] )
      __pc++
      loop
    else
      __pc := matchend( __pc+1,0 )
      loop
    endif

  case fTok == "IF"
    expr := right( ltrim( __1line), len( ltrim(__1line))-2)
    if lineEval( expr ) == .t.
      StackPush(iStack, {"IF"})
      __pc++
      varElse := .f.
      loop
    else
      varElse := .t.
      __pc := MatchIf( __pc+1,@varElse )
      if varElse == .t.
         StackPush(iStack, {"IF"})
      endif
      varElse := .f.
      loop
    endif

  case fTok == "LOOP"
   pos := FindIter( iStack )
   loopData := iStack[pos]
   if pos > 1
     for count := 1 to pos-1
        aDelete( iStack, 1 )
     next
   endif
   if loopData[1] == "WH"
    if lineEval( loopData[3] )
      __pc := loopData[2] +1
      loop
    else
      __pc := MatchEnd( __pc+1, pos-1 )
      StackPop( iStack )
      loop
    endif
   elseif loopData[1] == "FOR"
    eval( loopData[4] )
    if eval( forInfo[3] )
      __pc := forInfo[5]
      loop
    else
      __pc := Matchend(__pc+1, pos-1 )
      StackPop(iStack )
      loop
    endif
   endif

   case fTok == "EXIT"
     pos := FindIter( iStack )
     loopData := iStack[pos]
     if pos > 1
       for count := 1 to pos
          aDelete( iStack, 1 )
       next
     endif
     __pc := MatchEnd( __pc+1, pos-1 ) /* */
     loop


   case fTok == "DO"
      expr := alltrim (right( ltrim( __1line), len( ltrim(__1line))-2))
      if upper(expr) == "CASE"
         StackPush(iStack, {"CASE"})
         __pc++
         __cl++
         __isCaseEval := .f.
         loop
      elseif upper(expr) == "WHILE"
         expr := right( ltrim( __1line), len( ltrim(__1line))-5)
         if lineEval( expr ) == .t.
           StackPush( iStack, { "WH", __pc, expr } )
         else
           __pc := MatchEnd(  __pc+1,0 )
           loop
         endif
         __pc++
         loop

      else
       // Must be a PROC

        procname := token(__1line," ",2)
        __aparams := __getparams(__1line)

        procName := upper(procName)
        if (pos := ascan( subArray, {|x| x[1] ==  procName  } )) >0
            interpret(m->execode,subArray[pos,2],__aparams)
            __pc++
            loop
        else
            __temp := FindSub(  procName )
            aInsert( subArray,1, { procName, __temp} )
            interpret(m->execode,__temp,__aparams)
            __pc++
            loop
        endif
      endif




   case fTok == "CASE"
      If __IsCaseEval
        __pc := MatchEnd(  __pc+1,0 )
        __pc--
        loop
      Endif
      expr := right( ltrim( __1line), len( ltrim(__1line))-4)
      if LineEval(expr)
        __IsCaseEval := .t.
        __pc++
        loop
      else
        __pc := NextCase( __pc+1)
        loop
      endif

   case fTok == "OTHER"
        __pc++
        loop


   case fTok == "RETURN"
      __pc := StackPop( pcStack )
      if __pc == NIL
         retval := substr(ltrim( __1line),8)
         return RetEval(retval)
      endif
      loop

endcase
lineEval(__1line)
  __pc++
Enddo
return NIL

STATIC FUNCTION RetEval(retval)
If empty(retVal)
 return NIL
Endif

retVal := alltrim(upper(retval))
 Do Case
 Case left(retval,1) $['"]
  return retval
 Case isNumber(retVal)
  return val(retVal)
 EndCase
 return LineEval(retval)


STATIC FUNCTION __getparams(__cline)
Local __cParams,__pos,__var,__aVars := {}
__cLine := upper(__cLine)
__pos := at(" WITH ", __cLine)
If __pos == 0
 return NIL
Endif
__cParams := substr(__cLine,__pos+6)

While ! empty(__cParams)
 __var := parse(@__cParams,",")
 If empty(__var)
  loop
 Endif
 aadd(__aVars,&(alltrim(__var)))
Enddo
return __aVars






STATIC FUNCTION isNumber(cNum)
Local i
For i := 1 to len(cNum)
 if ! substr(cNum,i,1) $ "0123456789."
    return .f.
 Endif
Next
return .t.


STATIC FUNCTION lineEval(_1l)
locAL _1b
_1l := lclean(_1l)
_1b := &("{||"+_1l+"}")
return eval(_1b)

STATIC FUNCTION lclean(_1l)
_1l := strtran(_1l,";",",")
return ALLTRIM(_1l)



STATIC FUNCTION pNextline(_1str)
local _1p,_1s
_1p := at(chr(10),_1str)
if _1p == 0
  _1s := _1str
  _1str := ""
else
  _1s := left(_1str,_1p-1)
  _1str := substr(_1str,_1p+1)
Endif
return _1s

FUNCTION  _CreateBlock( _1s,_avar )
local cVars:= "" ,i,lfirst := .t.
If ! empty(_avar)
 For i := 1 to len(_avar)
  cVars+=_avar[i]+","
 Next
 cVars := left(cVars,len(cVars)-1)
Endif
return &("{|"+cVars+"|"+_1s+"}")


STATIC FUNCTION MatchEnd( line, depth )
local nextLine, fTok,ftok2

 while .t.
   nextLine := m->exeCode[line]
   fTok := upper(FirstTok( nextline ))
   ftok2 := token(nextline," ",2)

   do case
     case ascan( endArray, {|x| x == ftok } ) > 0
      if depth == 0
          return line+1
      else
          depth--
          line++
      endif
      loop


   case fTok == "WHILE"
     depth++
     line++
     loop

   case fTok == "FOR"
     depth++
     line++
     loop


   case fTok == "IF"
     depth++
     line++
     loop
   case fTok == "DO" .and. (ftok2 == "CASE" .or. ftok2 == "WHILE" )
     depth++
     line++
     loop



  endcase

   line++
   loop
 enddo
return line

STATIC FUNCTION MatchIf( line, elseOk )
local nextLine, fTok

 while .t.
   nextLine := m->exeCode[line]
   fTok := upper(FirstTok( nextline ))
   if ascan( ifArray, {|x| x == ftok } ) > 0
      if (fTok == "ELSE") .and. elseOk
          return line+1
      else
          return line
          elseOk := .f.
      endif
   endif
   line++
 enddo
return 1





STATIC FUNCTION FirstTok( line )
local sp

  line = ltrim( line )
  sp := at( " ", line )
return upper( substr( line,1,sp-1))


STATIC FUNCTION ForArray( line, pc )
local fArray := {"FOR", 1, 1, 1, pc }, init

   fArray[2] := token( line, " :=", 2 )

   init := &( "{||" +fArray[2] + ":=1}")
   eval(init)

   fArray[3] := &("{||" + fArray[2] + "<=" + token(line, " :=", 5) + "}" )
   fArray[4] := &("{||" + fArray[2] + ":="+fArray[2]+"+1}")
return fArray



STATIC FUNCTION FindIter( stack )
local count := 1, data

return ascan( stack, {|x| (x[1] == "WH") .or. (x[1] == "FOR") } )

STATIC FUNCTION  token( string,delims, occur )
local finding := .t., t:= 1, char, currentTok := 0
local tokPos, tokEndPos, token,toklen := len(string)

 If toklen == 0
  return ""
 Endif

  do while finding
    char := substr( string, t, 1 )      //  skip delimiters to get next
    while at(char, delims) > 0          //  token
       t++                              //
       char := substr( string, t, 1 )   //
    end                                 //

    If t > toklen
      return ""
    Endif

    tokPos := t
    t++
    char := substr( string, t, 1 )      //  find next delimiter
    while at(char, delims) == 0         //
       t++                              //
       char := substr( string, t, 1 )   //
    end                                 //



    tokEndPos := t
    currentTok++
    if currentTok == occur
      return substr( string, tokPos, tokEndPos- tokPos )
    end
  end

return 0

STATIC FUNCTION NextCase( line )
local nextLine, fTok

 while .t.
   nextLine := m->exeCode[line]
   fTok := FirstTok( nextline )
   if ascan( { "CASE","OTHER","OTHERWISE","ENDCASE"} , {|x| x == ftok } ) > 0
      return line
   else
      line++
   endif
 end
return 0



STATIC FUNCTION  FindSub( procName )
local nextLine, fTok, procGot, line := 1

 while .t.
   nextLine := m->exeCode[line]
   fTok := upper(FirstTok( nextline ))

   if fTok == "PROC"
      procGot := alltrim(token(nextline," ",2))
      if upper(procGot) == procName
        return( line+1 )
      endif
   endif
   line++
 enddo
return 0

STATIC FUNCTION Compile2A( _string_ )
local lcount, fTok, count, nextLine, exCode := {}
Local Varlist := {}
 _string_  := strtran(_string_,";",chr(13)+chr(10))


  lcount :=  mlcount(_string_,lINELENGTH,,.f.)

  for count := 1 to lcount
    nextLine := memoline(_string_,lINELENGTH,count,,.f.)
    NextLine := alltrim(Nextline)+" "

    If empty(nextLine)
     loop
    Endif

    If alltrim(substr(nextline,1,1)) == "#"
     loop
    Endif


    aadd(exCode,NextLine)
    Next

return exCode



STATIC FUNCTION AddToVarTable(line,len)
Local var,aVar := {}

Line := substr(line,len+1)

If empty(line)
 return NIL
Endif

While ! empty(line)
 var := parse(@line,",")
 If empty(var)
  loop
 Endif
 aadd(aVar,upper(alltrim(var)))
Enddo
return aVar

STATIC FUNCTION  parse( _getstr,_delimit)
LOCAL   _loc,_tempback ,l
_delimit:= if(_delimit == NIL," ",_delimit)
l := len(_delimit)
_loc := at(_delimit,_getstr)
_tempback = if(!empty(_loc),substr(_getstr,1,_loc-1),_getstr)
_getstr := if(!empty(_loc),substr(_getstr,_loc+l),"")
return(_tempback)


/**************************************************************************/
*STACK

STATIC FUNCTION StackNew()
   RETURN ( {} )     // Return an empty array


STATIC FUNCTION StackPush( aStack, xVal )
   
   // Add new element to the stack array and then return the array
   RETURN ( aInsert( aStack, 1, xVal ) )



STATIC FUNCTION StackPop( aStack )
   
   LOCAL xValueLast
   LOCAL nLen := LEN( aStack )

   // Check for underflow condition
   IF nLen == 0
      RETURN ( NIL )
   ENDIF

   // Get the last element value
   xValueLast := aStack[ 1  ]

   // Remove the last element by shrinking the stack
   aDelete( aStack,  1 )

   // Return the last element's value
   RETURN ( xValueLast )



STATIC FUNCTION StackIsEmpty( aStack )
   RETURN ( EMPTY( aStack ) )



STATIC FUNCTION StackTop( aStack )
   
   // Return the value of the last element in the stack array
   RETURN (  aStack[1] )


// End of Stack
****************************************************************************


STATIC FUNCTION aDelete(a_, pos)
  adel(a_, pos)
  asize(a_, len(a_) -1)
return nil


STATIC FUNCTION aInsert(a_, pos, value)
  asize(a_, len(a_) +1)
  ains(a_, pos)
  a_[pos] := value
return nil















