#include "script.ch"

// Declare all vars to be used as private
  PRIVATE  choice,oldscreen,block,data,i,oldcolor,prevcolor

// Set up data for achoice test
// Demonstates a FOR TO NEXT Loop with EXIT
   data := {}
   For i := 1 to 30
     aadd(data,"Row "+str(i))
     // Test loop exit
     If i == 20
       exit
     Endif
   Next

   setcolor("gr+/bg")
    cls
   @ 0,0 to 23,79 color "w+/b"
   setcolor("n/bg")

// @ Say's
   @1,3 say "An example of using a script file to execute clipper code"
   @2,3 say "Harris Software Systems , Auckland , New Zealand"

   setcolor("n/bg")

  WHILE .t.

    @ 9,34 to 13,49 DOUBLE
    prevcolor := setcolor("w+/b")

    @10,35 prompt "Iteration Test" Message "Test a For To Next loop for 500 iterations"
    @11,35 prompt "Achoice Test  " Message "Demo of Achoice called from script"
    @12,35 prompt "Exit Script   " Message "This will exit the script and return control to the program"

// Demonstates use of code blocks

   Menu to Choice

   setcolor(Prevcolor)

// Demonstates CASE statement

   DO CASE

    CASE Choice == 1
     // Demonstrates a Procedure call
     DO Iteration

    CASE Choice == 2
      // Nested Case
      DO CASE

       CASE choice == 1
       CASE choice == 2
         // Procedure with parameter
         Do aChoiceTest with data
       CASE choice == 3

      ENDCASE

    CASE choice == 3
     cls
     RETURN

    OTHER
      if choice == 0
        oldscreen := savescreen(0,0,24,79)
        @24,0 say "Esc Has been hit!! Press any key to continue"
        inkey(0)
        restscreen(0,0,24,79,oldscreen)
      Endif



   ENDCASE

 ENDDO

RETURN

PROC iteration
 PRIVATE oldscreen,nstart,i
 oldscreen := savescreen(0,0,24,79)
 nStart := seconds()
 @7,5 say "Iteration Test (500) "
 @8,5 say "Elapsed Time (Seconds)  "
  For i := 1 to 500
   @ 7,30 say str(i)
  Next
 @8, 30 say str(seconds()-nStart)
 @24,0 say "Press any key to continue"
 inkey(0)
 restscreen(0,0,24,79,oldscreen)
 return



PROC  AchoiceTest
 PARAMETERS testdata

 PRIVATE oldscreen,oldcolor

 oldscreen := savescreen(0,0,24,79)
 oldcolor := setcolor("gr+/w")
 @13,25 to 22,60
 achoice(14,26,21,59,testdata)
 setcolor(oldcolor)
 restscreen(0,0,24,79,oldscreen)
 RETURN



